// vjb30010.cpp : AvP[VpNX̒`s܂B
//

#include "stdafx.h"
#include "vjb30010.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVjb30010App

BEGIN_MESSAGE_MAP(CVjb30010App, CWinApp)
	//{{AFX_MSG_MAP(CVjb30010App)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVjb30010App NX̍\z

CVjb30010App::CVjb30010App()
{
	m_nRetCode = RC_NORMAL;
}

/////////////////////////////////////////////////////////////////////////////
// B CVjb30010App IuWFNg

CVjb30010App theApp;

/////////////////////////////////////////////////////////////////////////////
// CVjb30010App NX̏

//
//	@\	F	CX^XJn
//
//		F	
//
//	Al	F	FALSE - vOI
//
//	@\F	vO{̂̏B
//
//	l	F	vOJnɃt[[NĂ΂B
//
BOOL CVjb30010App::InitInstance()
{
	Param param;

	if ((m_nRetCode = GetParam(__argc, __argv, &param)) == 0)
		m_nRetCode = CreateQueueFile(&param);

	return FALSE;
}

//
//	@\	F	p[^擾
//
//		F	argc - p[^
//				argv - p[^e
//				pParam - p[^i[GA
//
//	Al	F	ʃR[h
//
//	@\F	R}hCp[^擾B
//
//	l	F	
//
int CVjb30010App::GetParam(int argc, char* argv[], Param *pParam)
{
	char *p;

	// p[^`FbN
	if (argc != 2) {
		DispMessage("p[^̐Ⴂ܂B");
		return RC_PARAMNUM;
	}

	// }̎ʃR[hA}̎ʃR[hAVolx擾
	if ((p = strtok(argv[1], ",")) == NULL) {
		DispMessage("p[^Ɍ肪܂B");
		return RC_PARAMVAL;
	}

	// p[^̕`FbN
	if (strlen(p) != LEN_TOTAL) {
		DispMessage("p[^̒Ⴂ܂B");
		return RC_PARAMLEN;
	}

	// }̎ʃR[hA}̎ʃR[hAVolx̕
	strncpy(pParam->cShubetsuCode, p, LEN_SHUBETSU_CODE);
	pParam->cShubetsuCode[LEN_SHUBETSU_CODE] = '\0';
	strncpy(pParam->cShikibetsuCode, p + POS_SHIKIBETSU_CODE, LEN_SHIKIBETSU_CODE);
	pParam->cShikibetsuCode[LEN_SHIKIBETSU_CODE] = '\0';
	strncpy(pParam->cVolLabel[0], p + POS_VOLUME_LABEL, LEN_VOLUME_LABEL);
	pParam->cVolLabel[0][LEN_VOLUME_LABEL] = '\0';

	// ǉVolx擾
	pParam->nVolLabel = 1;
	while ((p = strtok(NULL, ",")) != NULL) {
		// Volx`FbN
		if (pParam->nVolLabel >= MAX_VOLUME_LABEL) {
			DispMessage("Volx̐܂B");
			return RC_VOLNUM;
		}

		// Volx`FbN
		if (strlen(p) != LEN_VOLUME_LABEL) {
			DispMessage("Volx̒Ⴂ܂B");
			return RC_VOLLEN;
		}

		// Volx擾
		strcpy(pParam->cVolLabel[pParam->nVolLabel++], p);
	}

	return RC_NORMAL;
}

//
//	@\	F	L[t@C쐬
//
//		F	pParam - p[^i[GA
//
//	Al	F	ʃR[h
//
//	@\F	p[^L[t@C쐬B
//
//	l	F	
//
int CVjb30010App::CreateQueueFile(Param *pParam)
{
	char iniFile[256];
	char queueDir[256];
	char queueFile[256];
	SYSTEMTIME st;
	int i;
	HANDLE hFile;

	// ϐINIt@C擾
	if (GetEnvironmentVariable("VJBINIDIR", iniFile, sizeof(iniFile)) == 0)
		strcpy(iniFile, INI_FILE);
	else
		strcat(iniFile, "VJB30010.INI");

	// INIt@CL[t@CfBNg擾
	GetPrivateProfileString("QUEUE", "Dir", "", queueDir, sizeof(queueDir), iniFile);

	// VXet擾
	GetLocalTime(&st);

	// L[t@C쐬iVolxj
	sprintf(queueFile, "%s\\%04d%02d%02d%02d%02d%02d%s%sN",
			queueDir,
			st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond,
			pParam->cShubetsuCode, pParam->cShikibetsuCode);

	// Volxt
	for (i = 0; i < pParam->nVolLabel; i++) {
		if (i != 0)
			strcat(queueFile, ",");
		strcat(queueFile, pParam->cVolLabel[i]);
	}

	// L[t@C쐬
	hFile = CreateFile(
		queueFile,				// pointer to name of the file
		GENERIC_WRITE,			// access (read-write) mode
		FILE_SHARE_READ,		// share mode
		NULL,					// pointer to security attributes
		CREATE_ALWAYS,			// how to create
		FILE_ATTRIBUTE_NORMAL,	// file attributes
		NULL					// handle to file with attributes to copy
	);
	if (hFile == NULL) {
		DispMessage("L[t@C쐬ł܂B");
		return RC_QUEUEFILE;
	}
	CloseHandle(hFile);

	return RC_NORMAL;
}

//
//	@\	F	bZ[W\
//
//		F	msg - \bZ[W
//
//	Al	F	
//
//	@\F	bZ[W\B
//
//	l	F	fobÔݕ\
//
void CVjb30010App::DispMessage(LPCTSTR msg)
{
#if _DEBUG
	AfxMessageBox(msg);
#endif
}

//
//	@\	F	CX^XI
//
//		F	
//
//	Al	F	vOIR[h
//
//	@\F	vOIR[hԂB
//
//	l	F	vOIɃt[[NĂ΂B
//
int CVjb30010App::ExitInstance() 
{
	return m_nRetCode;
}
